	list p=16f88
	#include <p16f88.inc>
	radix dec

	errorlevel  -302 , -207             ; suppress message 302 from list file

	__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF




; Compiled with: PIC Simulator IDE v6.85
; Microcontroller model: PIC16F88
; Clock frequency: 4.0 MHz
;
;       The address of 'ledon' (byte) (global) is 0x2C
	ledon EQU 0x2C
;       The address of 'ledoff' (byte) (global) is 0x2D
	ledoff EQU 0x2D
;       The address of 'adcv0' (byte) (global) is 0x2E
	adcv0 EQU 0x2E
; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B


	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0003	;begin of prog

	ORG 0x0004
	RETFIE

; Begin of program
L0003:
; 1: 
; 2: AllDigital
	BSF STATUS,RP0
	CLRF 0x1B
	MOVLW 0x07
	MOVWF 0x1C
; 3: 
; 4: Dim ledon As Byte
; 5: Dim ledoff As Byte
; 6: 
; 7: 'adc set for 8 bit value
; 8: 
; 9: Dim adcv0 As Byte
; 10: 
; 11: Define ADC_CLOCK = 3
; 12: Define ADC_SAMPLEUS = 50 '50 microsec
; 13: 
; 14: ANSEL = 0x0f
	MOVLW 0x0F
	MOVWF 0x1B
; 15: TRISA = 0x0f
	MOVLW 0x0F
	MOVWF 0x05
; 16: TRISB = 0x00
	CLRF 0x06
; 17: ADCON1 = 0
	CLRF 0x1F
	BCF STATUS,RP0
; 18: 

; 19: ledon = 100 'hysteresis +1.97V LDR inp
	MOVLW 0x64
	MOVWF 0x2C
; 20: ledoff = 90 'LDR voltage + 1.77v
	MOVLW 0x5A
	MOVWF 0x2D
; 21: 
; 22: start:
L0001:
; 23: 
; 24: loop:
L0002:
; 25: Adcin 0, adcv0
	BSF STATUS,RP0
	BCF ADCON1,ADFM
	BCF ADCON1,ADCS2
	MOVLW 0x00
	BCF STATUS,RP0
	MOVWF R0L
	CALL A001
	MOVF ADRESH,W
	MOVWF 0x2E
; 26: 
; 27: 
; 28: If adcv0 < ledoff Then 'LDR lighter so LED off
	MOVF 0x2D,W	; ADRESH
	SUBWF 0x2E,W	; ledoff value
	BTFSC STATUS,C
	GOTO L0004
; 29: PORTB.0 = 0
	BCF 0x06,0	;LED off
; 30: Endif
L0004:
; 31: 
; 32: If adcv0 > ledon Then 'LDR darker so LED on
	MOVF 0x2E,W	;ADRESH
	SUBWF 0x2C,W	;ledon value
	BTFSC STATUS,C
	GOTO L0005
; 33: PORTB.0 = 1	
	BSF 0x06,0	;LED on
; 34: Endif

L0005:
; 35: 
; 36: Goto loop
	GOTO L0002
; 37: 
; 38: End


; 39: 
; End of program


;delay subr microsecs
; Waitus Routine - Byte Argument
X001:	MOVLW 0x0A
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
X002:	MOVLW 0x06
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002


; Read Adcin Routine
A001:	RLF R0L,F
	RLF R0L,F
	RLF R0L,F
	MOVLW 0x38
	ANDWF R0L,F
	MOVLW 0xC1
	IORWF R0L,W
	MOVWF ADCON0
	MOVLW 0x32
	MOVWF R4L
	CALL X001
	BSF ADCON0,GO
A002:	BTFSC ADCON0,GO
	GOTO A002
	BCF PIR1,ADIF
	BCF ADCON0,ADON
	RETURN

; End of listing
	END
